.586
.model FLAT,stdcall
.code


IP_ADDRESS_STRING struct
	String db 16 dup (?)
IP_ADDRESS_STRING ends


IP_ADDR_STRING struct
	Next		dd ?
	IpAddress 	db 16 dup (?)
	IpMask	  	db 16 dup (?)
	Context		dd ?	
IP_ADDR_STRING ends



IP_ADAPTER_INFO struct
	Next			dd ?
	ComboIndex 		dd ?
	AdapterName		db 260 dup (?)
	Description		db 132 dup (?)
	AddressLength		dd ?
	Address			db 8 dup (?)
	Index			dd ?
	tType			dd ?
	DhcpEnabled		dd ?
	CurrentIpAddress 	dd ?
	IpAddressList		IP_ADDR_STRING <>
	GatewayList		IP_ADDR_STRING <>
	DhcpServer		IP_ADDR_STRING <>
	HaveWins		dd ?
	PrimaryWinsServer	IP_ADDR_STRING <>
	SecondaryWinsServer	IP_ADDR_STRING <>
	LeaseObtained		dd ?
	LeaseExpires		dd ?
IP_ADAPTER_INFO ends

PUBLIC GetMacAddress

LoadLibrary textequ <LoadLibraryA>

LoadLibrary proto :DWORD
GetProcAddress proto :DWORD,:DWORD
FreeLibrary proto :DWORD

GetMacAddress proc uses eax ebx ecx edx pOut
	local pDLL
	local AdInfo[8]:IP_ADAPTER_INFO,dwBufLen
	local str1[8]:DWORD

	
	
	
	mov dwBufLen,IP_ADAPTER_INFO*8
	
	.data
		ishapi_ db "iphlpapi.dll",0
		getada_ db "GetAdaptersInfo",0
	.code
	invoke LoadLibrary,addr ishapi_
	mov pDLL,eax
	test eax,eax
	jz _bad
	mov pDLL,eax

	; make str1 = "GetAdaptersInfo"
	invoke GetProcAddress,eax,addr getada_
	test eax,eax
	jz _bad
	
	lea ecx,AdInfo
	lea edx,dwBufLen
	push edx
	push ecx
	call eax
	test eax,eax
	jnz _bad
	
	
	;----------[ do stuff with the AdInfo.Address ]-------------\
	; it's the MAC address of the first NIC
	;-----------------------------------------------------------/
	
	.if pDLL
		invoke FreeLibrary,pDLL
	.endif
	
	mov eax,1
	ret
	
_bad:
	; handle missing-NIC somehow
	
	ret
GetMacAddress endp


end
